Bug 1483499 - Review Request: gnome-remote-desktop - Remote desktop server for GNOME
Review Request: gnome-remote-desktop - Remote desktop server for GNOME
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
27
All Linux
unspecified Severity medium
: ---
: ---
Assigned To: Robert-André Mauchin
Fedora Extras Quality Assurance
:
Depends On:
Blocks: FE-NEEDSPONSOR
  Show dependency treegraph
 
Reported: 2017-08-21 05:29 EDT by Jonas Ådahl
Modified: 2017-09-30 02:15 EDT (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2017-09-30 02:15:14 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
zebob.m: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Jonas Ådahl 2017-08-21 05:29:11 EDT
Spec URL: https://people.freedesktop.org/~jadahl/gnome-remote-desktop.spec
SRPM URL: https://copr-be.cloud.fedoraproject.org/results/jadahl/gnome-remote-desktop/fedora-rawhide-x86_64/00592153-gnome-remote-desktop/gnome-remote-desktop-0.1.1-1.fc28.src.rpm

Description:

This is the remote desktop service implementation meant to provide remote desktop functionality to the Wayland session in GNOME. It is implemented by utilizing a D-Bus API exposed by GNOME Shell, that creates PipeWire streams that'll be consumed by a gnome-remote-desktop-daemon process which implements a VNC server.

The branch implementing the GNOME Shell side (implemned in libmutter) has not landed yet, and will initially be disabled by default, but possible to enable by adding strings to the org.gnome.mutter.experimental-features gsetting.

It is managed as a systemd user process by GNOME Settings Daemon and GNOME Control Center.

Fedora Account System Username: jadahl
Comment 1 Jonas Ådahl 2017-08-21 06:06:57 EDT
FWIW, there are a couple of things missing (%systemd_user_... and glib-compile-schemas) in the .spec.
Comment 2 Robert-André Mauchin 2017-08-21 09:01:26 EDT
Hello,

 - I'd prefer you use spaces instead of tabs.

 - systemd user unit files must be placed in %{_userunitdir}, not %{_libdir}/systemd/user/ because they are system independent, otherwise libdir would resolve to lib64. See https://fedoraproject.org/wiki/Packaging:Systemd I don't know how meson work and if you can change the location of the unit file with a command line argument, if you can't, move it in %install:

%{__mkdir_p} $RPM_BUILD_ROOT/%{_userunitdir}
%{__mv} $RPM_BUILD_ROOT/%{_libdir}/systemd/user/gnome-remote-desktop.service $RPM_BUILD_ROOT/%{_userunitdir}/gnome-remote-desktop.service

Then in your %files:

%{_userunitdir}/gnome-remote-desktop.service

 - You also need to use systemd scriplets in %post, %preun, %postun: see https://fedoraproject.org/wiki/Packaging:Scriptlets?rd=Packaging:ScriptletSnippets#Systemd

%post
%systemd_post %{name}.service


%preun
%systemd_preun %{name}.service


%postun
%systemd_postun_with_restart %{name}.service


 - You also need to add a BR with a special macro:

%{?systemd_requires}
BuildRequires: systemd

 - The description should be split in multiples lines in order to be below <80 characters
Comment 3 Jonas Ådahl 2017-08-21 09:31:51 EDT
(In reply to Robert-André Mauchin from comment #2)
> Hello,
> 
>  - I'd prefer you use spaces instead of tabs.

Not sure where they come from, but me typing 'vim asdf.spec' will use some template that uses spaces. (I'll update the spec file to use spaces)

> 
>  - systemd user unit files must be placed in %{_userunitdir}, not
> %{_libdir}/systemd/user/ because they are system independent, otherwise
> libdir would resolve to lib64. See
> https://fedoraproject.org/wiki/Packaging:Systemd I don't know how meson work
> and if you can change the location of the unit file with a command line
> argument, if you can't, move it in %install:
> 
> %{__mkdir_p} $RPM_BUILD_ROOT/%{_userunitdir}
> %{__mv} $RPM_BUILD_ROOT/%{_libdir}/systemd/user/gnome-remote-desktop.service
> $RPM_BUILD_ROOT/%{_userunitdir}/gnome-remote-desktop.service
> 
> Then in your %files:
> 
> %{_userunitdir}/gnome-remote-desktop.service

Seems I should be able to get the user service dir from pkgconfig.

> 
>  - You also need to use systemd scriplets in %post, %preun, %postun: see
> https://fedoraproject.org/wiki/Packaging:Scriptlets?rd=Packaging:
> ScriptletSnippets#Systemd
> 
> %post
> %systemd_post %{name}.service
> 
> 
> %preun
> %systemd_preun %{name}.service
> 
> 
> %postun
> %systemd_postun_with_restart %{name}.service
> 
> 
>  - You also need to add a BR with a special macro:
> 
> %{?systemd_requires}
> BuildRequires: systemd
> 
>  - The description should be split in multiples lines in order to be below
> <80 characters

Thanks for the review.
Comment 4 Robert-André Mauchin 2017-08-21 09:56:26 EDT
I didn't see you needed a sponsor. Try to help around making informal reviews to show that you understand the guidelines, maybe introduce yourself on fedora-devel, and hopefully you'll find a sponsor.
Comment 6 Robert-André Mauchin 2017-08-22 02:47:49 EDT
The glib-compile-schemas scriplets are not needed on F24+:

  This scriptlet SHOULD NOT be used in Fedora 24 or later.

Cf https://fedoraproject.org/w/index.php?title=Packaging:Scriptlets&oldid=481889#GSettings_Schema
Comment 7 Jonas Ådahl 2017-08-22 02:53:04 EDT
(In reply to Robert-André Mauchin from comment #6)
> The glib-compile-schemas scriplets are not needed on F24+:
> 
>   This scriptlet SHOULD NOT be used in Fedora 24 or later.
> 
> Cf
> https://fedoraproject.org/w/index.php?title=Packaging:
> Scriptlets&oldid=481889#GSettings_Schema

Interesting. Is glib-compile-schemas run automatically some how? I needed to run that locally to make code using gsettings find the corresponding schema.
Comment 8 Robert-André Mauchin 2017-08-22 04:03:11 EDT
>Is glib-compile-schemas run automatically some how?
Normally yes.
Comment 11 Robert-André Mauchin 2017-08-24 06:06:49 EDT
All good, package accepted.


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "GPL (v2 or later) (with incorrect FSF address)", "Unknown or
     generated". 13 files have unknown license. Detailed output of
     licensecheck in /home/bob/packaging/review/gnome-remote-desktop
     /review-gnome-remote-desktop/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in gnome-
     remote-desktop-debuginfo
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: There are rpmlint messages (see attachment).
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: gnome-remote-desktop-0.1.2-2.fc28.x86_64.rpm
          gnome-remote-desktop-debuginfo-0.1.2-2.fc28.x86_64.rpm
          gnome-remote-desktop-0.1.2-2.fc28.src.rpm
gnome-remote-desktop.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
gnome-remote-desktop.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
gnome-remote-desktop.x86_64: W: empty-%postun
3 packages and 0 specfiles checked; 0 errors, 3 warnings.
Comment 12 Kalev Lember 2017-08-25 00:42:32 EDT
Thanks for the review, Robert-André. I'll sponsor Jonas; looks like solid packaging to me.

(In reply to Jonas Ådahl from comment #7)
> Interesting. Is glib-compile-schemas run automatically some how? I needed to
> run that locally to make code using gsettings find the corresponding schema.

Yes. We have rpm file triggers in the glib2 package that automatically trigger schema recompilation when some package drops a file in %{_datadir}/glib-2.0/schemas/. It doesn't work on RHEL 7 though as the rpm there is too old, so if you want to have the package there you'll need to add the schema compilation rpm scripts back.

As for the packaging here, I'd change two things. First, the complicated "%setup -q -T -b0 -n %{name}-%{version}" line shouldn't be needed here. I'd suggest to replace that with just '%autosetup' or '%autosetup -p1'.

Second, you'll need to install the COPYING file (this is mandatory as per the packaging guidelines). For this, add '%license COPYING' as the first item under the %files list which then takes care of automatically copying it to /usr/share/licenses/.

Anyway, welcome to the Fedora packaging world, Jonas! I've just sponsored you. Feel free to contact me when you need help figuring out how to do things :)
Comment 14 Igor Gnatenko 2017-08-30 06:38:54 EDT
> BuildRequires:  pkgconfig
not needed

> Source0:        https://gitlab.gnome.org/jadahl/gnome-remote-desktop/uploads/7d3cc32efb12ca84284532f947487067/gnome-remote-desktop-0.1.2.tar.xz
Please don't specify commit hash here, look at https://fedoraproject.org/wiki/Packaging:SourceURL?rd=Packaging/SourceURL#Git_Tags

Otherwise looks good to me.
Comment 15 Jonas Ådahl 2017-08-31 03:13:46 EDT
(In reply to Igor Gnatenko from comment #14)
> > BuildRequires:  pkgconfig
> not needed
> 
> > Source0:        https://gitlab.gnome.org/jadahl/gnome-remote-desktop/uploads/7d3cc32efb12ca84284532f947487067/gnome-remote-desktop-0.1.2.tar.xz
> Please don't specify commit hash here, look at
> https://fedoraproject.org/wiki/Packaging:SourceURL?rd=Packaging/
> SourceURL#Git_Tags

That is not a commit hash, but the URL of a tar ball I created with git archive locally. Removing the hash results in a 404.
Comment 16 Gwyn Ciesla 2017-08-31 09:11:57 EDT
(fedrepo-req-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/gnome-remote-desktop
Comment 17 Fedora Update System 2017-09-04 04:46:33 EDT
gnome-remote-desktop-0.1.2-3.fc27 has been submitted as an update to Fedora 27. https://bodhi.fedoraproject.org/updates/FEDORA-2017-d8232a4821
Comment 18 Fedora Update System 2017-09-04 18:53:08 EDT
gnome-remote-desktop-0.1.2-3.fc27 has been pushed to the Fedora 27 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-d8232a4821
Comment 19 Fedora Update System 2017-09-30 02:15:14 EDT
gnome-remote-desktop-0.1.2-3.fc27 has been pushed to the Fedora 27 stable repository. If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.